const express = require('express');
const app = express();
const path = require('path');
const bodyParser = require('body-parser');
const fs = require('fs');
const childProcess = require('child_process');

const PORT = 8080;
const HOSTNAME = 'localhost';

app.use(express.static(path.resolve(__dirname, './src')));
app.use(bodyParser.json({ limit: '10mb' }));

app.post('/widths', function (req, res) {
  Object.keys(req.body).forEach((font) => {
    fs.writeFile(`fonts/${font}.csv`,
      Object.keys(req.body[font]).map((codePoint) => [codePoint].concat(req.body[font][codePoint]).join(',')).join('\n'),
      (err) => {
        if (err) throw err;
      });
    console.log(`${font} correctly stored`);
  });

  server.close();
  res.end();
});

const codePoints = require('unicode-10.0.0/Binary_Property/Assigned/code-points.js');
fs.writeFile(`src/assignedCodePoints.js`, `var codePoints = ${JSON.stringify(codePoints)};`, (err) => {
  if (err) throw err;
});

const server = app.listen(PORT, HOSTNAME, err => {
  if (err) {
    throw err;
  }

  childProcess.execSync(`open http://${HOSTNAME}:${PORT}/unicodePixelWidthCalculator.html`);
});
console.log('Server started!');
